package  
{
	import com.bit101.components.CheckBox;
	import com.bit101.components.PushButton;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import net.hires.debug.Stats;
	
	/**
	 * ...
	 * @author sewonist
	 */
	public class Figure3 extends Sprite
	{
		const MAX_NUM:int = 50;
		
		private var _flowers:Array;
		private var _flower:Flower;
		
		private var _holder:Sprite; 
		private var _stats:Stats;
		private var _cacheCheckbox:CheckBox;
		private var _rotationCheckbox:CheckBox;
		private var _startButton:PushButton;
		private var _stopButton:PushButton;
		private var _components:Sprite;
		
		public function Figure3() 
		{
			if (stage) {
				initialize();
			} else {
				stage.addEventListener(Event.ADDED_TO_STAGE, initialize);
			}
		}
		
		private function initialize(e:Event=null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, initialize);
			
			initFlowers();
			initGUI();
		}
		
		private function initFlowers():void
		{
			_holder = new Sprite;
			addChild(_holder);
			
			_flowers = [];
			for (var i:int = 0; i< MAX_NUM; i++) { 
				_flower = new Flower; 
				
				_flower.destinationX = Math.random()*stage.stageWidth; 
				_flower.destinationY = Math.random()*stage.stageHeight; 
				_flower.x = Math.random()*stage.stageWidth; 
				_flower.y = Math.random() * stage.stageHeight; 
				
				_flowers[i] = _flower; 
				
				_holder.addChild(_flower); 
			} 
		}
		
		private function initGUI():void
		{
			_startButton = new PushButton;
			_startButton.label = "Start";
			_startButton.addEventListener(MouseEvent.CLICK, handleStartButon);
			
			_stopButton = new PushButton;
			_stopButton.label = "Stop";
			_stopButton.addEventListener(MouseEvent.CLICK, handleStopButon);
			
			_cacheCheckbox = new CheckBox;
			_cacheCheckbox.label = "cacheAsBitmap";
			_cacheCheckbox.addEventListener(MouseEvent.CLICK, handleCacheCheckbox);
			
			_rotationCheckbox = new CheckBox;
			_rotationCheckbox.label = "rotation";
			
			_stats = new Stats({ bg: 0x333333});
			
			_components = new Sprite;
			_components.graphics.beginFill(0x333333);
			_components.graphics.drawRect(0, 0, 180, 100);
			_components.graphics.endFill();
			
			_components.addChild(_stats);
			_components.addChild(_rotationCheckbox);
			_components.addChild(_cacheCheckbox);
			_components.addChild(_startButton);
			_components.addChild(_stopButton);
			
			_startButton.x = 70;
			_startButton.y = 10;
			
			_stopButton.x = 70;
			_stopButton.y = 35;
			
			_cacheCheckbox.x = 70;
			_cacheCheckbox.y = 65;
			
			_rotationCheckbox.x = 70;
			_rotationCheckbox.y = 80;
			
			addChild(_components);
		}
		
		
		private function handleStartButon(e:MouseEvent):void 
		{
			addEventListener(Event.ENTER_FRAME, handleEnterFrame);
		}
		
		private function handleStopButon(e:MouseEvent):void 
		{
			removeEventListener(Event.ENTER_FRAME, handleEnterFrame);
		}
		
		private function handleCacheCheckbox(e:MouseEvent):void 
		{
			var len:int = _flowers.length;
			for (var i:int = 0; i < len; i++) 
			{ 
				_flowers[i].cacheAsBitmap = _cacheCheckbox.selected; 
			} 
		}
		
		function handleEnterFrame(e:Event):void 
		{     
			var len:int = _flowers.length;
			for (var i:int = 0; i < len; i++) 
			{ 
				_flower = _flowers[i]; 
				
				_flower.x -= (_flower.x - _flower.destinationX) *.5; 
				_flower.y -= (_flower.y - _flower.destinationY) * .5;
				
				if (_rotationCheckbox.selected) {
					_flower.rotation += 1;
				}
				
				if (Math.abs(_flower.x - _flower.destinationX ) < 1 &&      
					Math.abs(_flower.y - _flower.destinationY ) < 1) 
				{ 
						_flower.destinationX = Math.random()*stage.stageWidth; 
						_flower.destinationY = Math.random()*stage.stageHeight; 
				} 
			} 
		}
		
	}

}

class Flower extends FlowerVector {
	public var destinationX:Number;
	public var destinationY:Number;
	
	public function Flower()
	{
		super();
	}
}